#include <stdio.h>
#include <stdlib.h>

#include "Pilha.h"

int PEmpilha(TPilha* pTPilha,TItemP* pTItemP)
{
	TCellP* pTCellAux;

	pTCellAux = (TCellP*) malloc(sizeof(TCellP));

	if (pTCellAux == NULL)
	{
		fprintf(stderr,"Error while alloc memory!\n");
		return 0;
	}

	pTCellAux->item = *pTItemP;
	if (pTPilha->pstTop == NULL)
		pTCellAux->pstProx = NULL;
	else
		pTCellAux->pstProx = pTPilha->pstTop;

	pTPilha->pstTop = pTCellAux;

	return 1;
}

int PDesempilha (TPilha* pTPilha,TItemP* pTItemP)
{
	TCellP* pTCellAux;

	if (pTPilha->pstTop == NULL)
		return 0;

	*pTItemP  = pTPilha->pstTop->item;
	pTCellAux = pTPilha->pstTop;
	pTPilha->pstTop = pTPilha->pstTop->pstProx;

	free(pTCellAux);

	return 1;
}

int PEhVazia(TPilha* pTPilha)
{
	if (pTPilha->pstTop == NULL)
		return 1;
	else
		return 0;
}

void FPVazia(TPilha* pTPilha)
{
	pTPilha->pstTop = NULL;
}

