#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "PilhaAD.h"

int FPVazia(TPilha* pPilha,int MaxTam)
{
  pPilha->iMaxTam = MaxTam;
  pPilha->vItem = (TItemPAD*)malloc(sizeof(TItemPAD)*pPilha->iMaxTam);
  if (pPilha->vItem == NULL)
	return 0;
  pPilha->iTopo = 0;
  return 1;
} /* FPVazia */

int PLibera(TPilha* pPilha)
{
	if (pPilha->vItem != NULL)
		free(pPilha->vItem);
	else
		return 0;

	pPilha->iMaxTam = 0;
	pPilha->iTopo = 0;
	pPilha->vItem = NULL;

	return 1;
}

int PEhVazia(TPilha* pPilha)
{
  return (pPilha->iTopo == 0);
} /* Vazia */

int PEmpilha(TPilha*   pPilha, 
             TItemPAD* pItem)
{
  if (pPilha->iTopo == pPilha->iMaxTam)
    return 0;

  pPilha->vItem[pPilha->iTopo] = *pItem;
  pPilha->iTopo++;
	return 1;
} /* PEmpilha */

int PDesempilha(TPilha*   pPilha,
                TItemPAD* pItem)
{
  if (PEhVazia(pPilha))
    return 0;

  pPilha->iTopo--;
  *pItem = pPilha->vItem[pPilha->iTopo];
  return 1;
} /* PDesempilha */


int PTamanho(TPilha* pPilha)
{
  return (pPilha->iTopo);
} /* Tamanho */

