#ifdef _WIN32 //| _WIN64


#include <tchar.h>
#include <windows.h>

typedef struct{
	LARGE_INTEGER start;
	LARGE_INTEGER stop;
} StopWatch;

double LIToSecs(LARGE_INTEGER*);
double GetElapsedTime(StopWatch*);


#else


#include <time.h>

typedef struct {
	struct timespec start;
	struct timespec stop;
}  StopWatch;

long double GetElapsedTime(StopWatch*);


#endif


void StartTimer(StopWatch*);
void StopTimer(StopWatch*);
